open Interval;;
open Box
open Constr

type witness = (float array * bool) option

val prune: constr -> box -> bool -> Intset.t -> bool-> witness
  (* prunes #2 wrt. #1, i.e. if #3 is false then prune wrt. negation of #1; 
     #4 contains a list of variables for which #2 changed since the last #3-pruning; 
     if #5 then a single sample suffices for pruning the whole box (in that case empty box+witness returned)
     see research/papers/local/sampling
   *)

val prune_crude: constr -> box -> unit
(* prunes #2 wrt. #1, does not use any information on changes of free vars since previous pruning *)

val prune_crude_neg: constr -> box -> unit
(* prunes negation of #2 wrt. #1, does not use any information on changes of free vars since previous pruning*)

val compute_sample: Constr.constr -> Box.box -> bool (* neg *) -> witness
(* try to find a sample point (not iff 'neg') fulfilling the constraint within the box *)

val print_witness: witness -> unit

val flag_shortcut: bool ref
val flag_remove: bool ref
val flag_marks: bool ref
val flag_sample: bool ref
val flag_sample_approximate: bool ref

(* val fixpoint_check: float ref *)

val deduce_atomic_ctr: int ref
val deduce_primitive_ctr: int ref
val improve_atomic_ctr: int ref
val mark_cons_ctr: int ref



